//---------------------------------------------------------------------------

#ifndef CGiButtonH
#define CGiButtonH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <Controls.hpp>
//---------------------------------------------------------------------------
class TRGB : public TPersistent
 {
  private:
        int FpasR, FpasG, FpasB;
        TNotifyEvent FOnChange;
  public:
        __fastcall TRGB();
  protected:
        virtual void __fastcall Change();
        virtual void __fastcall SetpasR(int Value);
        virtual void __fastcall SetpasG(int Value);
        virtual void __fastcall SetpasB(int Value);
  __published:
        __property int pasR =  {read=FpasR, write=SetpasR, default = 1};
        __property int pasG =  {read=FpasG, write=SetpasG, default = 1};
        __property int pasB =  {read=FpasB, write=SetpasB, default = 1};
        __property TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
 };
//---------------------------------------------------------------------------
class PACKAGE TCGiButton : public TCustomControl
{
private:
        TRGB *FRGB;
        TFont *FFont;
        bool BtnEnfonce;
        bool BtnEnfonceBis;
        bool MouseSurBtn;
        bool ALeFocus;
protected:
        void __fastcall RGBChange(TObject *Sender);
        void __fastcall Paint();
        DYNAMIC void __fastcall DoEnter();
        DYNAMIC void __fastcall DoExit();
        DYNAMIC void __fastcall MouseDown(TMouseButton Button,
                                      Classes::TShiftState Shift, int X, int Y);
        DYNAMIC void __fastcall MouseUp(TMouseButton Button,
                                      Classes::TShiftState Shift, int X, int Y);
        DYNAMIC void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
        DYNAMIC void __fastcall KeyUp(Word &Key, Classes::TShiftState Shift);
        bool __fastcall CanResize(int &NewWidth, int &NewHeight);
        virtual void __fastcall SetFont(TFont *Value);
        virtual void __fastcall SetRGB(TRGB *Value);
        void __fastcall FontChanged(TObject *Sender);
        virtual void __fastcall MouseLeave(TMessage &Msg);
        virtual void __fastcall MouseEnter(TMessage &Msg);
        virtual void __fastcall TextChanged(TMessage &Msg);
        void __fastcall SetEnabled(bool Value);
BEGIN_MESSAGE_MAP
    MESSAGE_HANDLER(CM_MOUSELEAVE, TMessage, MouseLeave)
    MESSAGE_HANDLER(CM_MOUSEENTER, TMessage, MouseEnter)
    MESSAGE_HANDLER(CM_TEXTCHANGED, TMessage, TextChanged)
END_MESSAGE_MAP(TCustomControl)
public:
        __fastcall TCGiButton(TComponent* Owner);
        virtual __fastcall ~TCGiButton();
__published:
        __property Caption;
        __property Enabled;
        __property OnClick;
        __property OnKeyUp;
        __property OnKeyPress;
        __property OnKeyDown;
        __property OnEnter;
        __property OnExit;
        __property TabOrder;
        __property TabStop;
        // nouvelles proprits :
        __property TFont *Font =  {read=FFont, write=SetFont};
        __property TRGB *CRGB =  {read=FRGB, write=SetRGB};

};
//---------------------------------------------------------------------------
#endif
